VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SortedCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Items As Collection
' Add an item at its correct position.
Public Sub AddItem(ByVal new_item As String)
Dim i As Integer

    ' See where the item belongs.
    For i = 1 To m_Items.Count
        If m_Items(i) >= new_item Then Exit For
    Next i

    ' Insert the item.
    If i > m_Items.Count Then
        ' Add at the end.
        m_Items.Add new_item
    Else
        ' Add at the right position.
        m_Items.Add new_item, , i
    End If
End Sub
' Return the number of items.
Public Function Count() As Integer
    Count = m_Items.Count
End Function
' Remove an item.
Public Sub Remove(ByVal Index As Integer)
    m_Items.Remove Index
End Sub

' Return an item.
'
' Note: This is the SortedCollection's default property
' so a program can use: sorted_collection(K) to get the
' Kth item.
'
' To make this the default property:
'   1. Open the SortedCollection's class editor window.
'   2. Select the Tools menu's Procedure Attributes command.
'       a. Select Item in the Name box.
'       b. Click Advanced >>
'       c. Select (Default) in the Procedure ID box.
'       d. Click Ok.
Public Function Item(ByVal Index As Integer) As String
Attribute Item.VB_UserMemId = 0
    Item = m_Items(Index)
End Function
' Implement the enumerator used by For Each loops. This
' function must return an IUnknown interface. You can
' get one from a standard Collection's _NewEnum method.
'
' To enable For Each, you must also give this function
' the right procedure ID. To do that:
'   1. Open the SortedCollection's class editor window.
'   2. Select the Tools menu's Procedure Attributes command.
'       a. Select NewEnum in the Name box.
'       b. Click Advanced >>
'       c. Click on the Procedure ID box and type -4.
'       d. Check the "Hide this member" box so the user
'          cannot see this method (it's really only
'          useful indirectly via For each).
'       e. Click Ok.
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
   Set NewEnum = m_Items.[_NewEnum]
End Function
' Create the new collection.
Private Sub Class_Initialize()
    Set m_Items = New Collection
End Sub


